# Copyright 2005 by
#           Atte Timonen
#           Tarmo Toikkanen
#           Teemu Leinonen
#           Lily Diaz
#           Janne Pietarila
#
# Code snippets used from Fle3 (fle3.uiah.fi),
# credits go to the Fle3 Team.
#
# This file is part of the ImaNote product.
#
# ImaNote is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# ImaNote is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with ImaNote; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

from math import log, ceil

def log2(x): return log(x) / log(2)
def roundup(x): return int(ceil(x))
PERM_VIEW = 'View'
PERM_EDIT = 'Edit'
PERM_MANAGE = 'Manage ImaNote' # FIXME: What we should use here?

try:
  foo=False
  del foo
except NameError: #python <2.2
  False=0
  True=1

class IDManager:

    def __init__(self):
        self.__id_counter = -1L
    # Overrides generate_id from Thread!

    def generateId(self):
        #"""Return a probably unique integer."""
        self.__id_counter += 1L
        return 'a'+str(self.__id_counter)

def getLocalRoles(obj, person):
    roles = []
    o=obj.aq_base
    if hasattr(o,'get_local_roles'):
        for tuples in o.get_local_roles():
            if tuples[0] == person:
                roles = roles + list(tuples[1])
    return tuple(roles)

import urllib
from urllib import splithost, splituser, splittype, unquote, addinfourl
import httplib
import types
class HeaderURLopener(urllib.FancyURLopener):
  def open_http(self, url, data=None):
    """Use HTTP protocol."""
    user_passwd = None
    if type(url) is types.StringType:
        host, selector = splithost(url)
        if host:
            user_passwd, host = splituser(host)
            host = unquote(host)
        realhost = host
    else:
        host, selector = url
        urltype, rest = splittype(selector)
        url = rest
        user_passwd = None
        if urltype.lower() != 'http':
            realhost = None
        else:
            realhost, rest = splithost(rest)
            if realhost:
                user_passwd, realhost = splituser(realhost)
            if user_passwd:
                selector = "%s://%s%s" % (urltype, realhost, rest)
            if proxy_bypass(realhost):
                host = realhost

        #print "proxy via http:", host, selector
    if not host: raise IOError, ('http error', 'no host given')
    if user_passwd:
        import base64
        auth = base64.encodestring(user_passwd).strip()
    else:
        auth = None
    h = httplib.HTTP(host)
    if data is not None:
        h.putrequest('POST', selector)
        h.putheader('Content-type', 'application/x-www-form-urlencoded')
        h.putheader('Content-length', '%d' % len(data))
    else:
      h.putrequest('HEAD', selector)
    if auth: h.putheader('Authorization', 'Basic %s' % auth)
    if realhost: h.putheader('Host', realhost)
    for args in self.addheaders: apply(h.putheader, args)
    h.endheaders()
    if data is not None:
        h.send(data)
    errcode, errmsg, headers = h.getreply()
    fp = h.getfile()
    if errcode == 200:
        return addinfourl(fp, headers, "http:" + url)
    else:
        if data is None:
            return self.http_error(url, fp, errcode, errmsg, headers)
        else:
            return self.http_error(url, fp, errcode, errmsg, headers, data)

def reallyHasattr(self, id):
  return hasattr(self.aq_base, id)
