# Copyright 2005 by
#           Atte Timonen
#           Tarmo Toikkanen
#           Teemu Leinonen
#           Lily Diaz
#           Janne Pietarila
#
# Code snippets used from Fle3 (fle3.uiah.fi),
# credits go to the Fle3 Team.
#
# This file is part of the ImaNote product.
#
# ImaNote is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# ImaNote is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with ImaNote; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

import os, sys, re, pdb
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
import TiledImage
from tests import * 
from Annotation import *

class TestImage(ZopeTestCase.ZopeTestCase):

    def afterSetUp(self):
        pass

    def testTiles(self):
      try:
        made.testImage.getTile(25,100,100)
      except:
        pass
      else:
        self.fail("Getting a nonexistent tile did not raise exception")
      assert made.testImage.getTile(0,1,1), "Image tiles not found"
      made.testImage.addTile(24,100,100,'1234567')
      assert (made.testImage.getTile(24,100,100)=='1234567'), \
          "Added tile was not found"
    def testOverviewImage(self):
      made.testImage.setOverviewImageSize(100,100)
      aspect_ratio=(float(im_width)/float(im_height))
      from math import fabs
      assert fabs(made.testImage._overview_height*aspect_ratio-\
          made.testImage._overview_width) <=1.5, \
          "Overview image aspect ratio not same as original image aspect ratio"
      assert made.testImage._overview_width<=100 \
          and made.testImage._overview_height<=100, \
        "Overview image too big"

      
    def testImage(self):
      im=made.testImage.get_image(0,100,100,640,480)
      assert re.search('PNG', im), 'A png image was not returned'
      im=made.testImage.get_image(0,100,100,640,480,format='jpeg')
      assert re.search('JFIF', im), 'A jpeg image was not returned'
      id=made.generateId()
      made.testImage.addAnnotation(Annotation(10,10,50,50,id))
      made.testImage.getAnnotation(id).editData(text='foo')     
      im2=made.testImage.get_image(0,100,100,640,480,format='jpeg')
      assert im2!=im, "Adding annotation didn't affect image"

def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestImage))
    return suite

if __name__ == '__main__':
    framework()

