# Copyright 2005 by
#           Atte Timonen
#           Tarmo Toikkanen
#           Teemu Leinonen
#           Lily Diaz
#           Janne Pietarila
#
# Code snippets used from Fle3 (fle3.uiah.fi),
# credits go to the Fle3 Team.
#
# This file is part of the ImaNote product.
#
# ImaNote is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# ImaNote is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with ImaNote; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA


import os, sys, pdb
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
from TiledImage import *
from Annotation import *
from tests import * 
import re
import AccessControl

class TestUiAnnotations(ZopeTestCase.FunctionalTestCase):

    def afterSetUp(self):
      self.basic_auth='%s:%s' % (ZopeTestCase.user_name,ZopeTestCase.user_password)

    def testCreation(self):
      pass

      ##################
      #FIXME Authentication through ZPublisher doesn't work, even though
      #self.app.testMade.restrictedTraverse("add_annotation_handler_step_1")
      #grants access.
      #pdb.set_trace()
      #self.login()
      #self.setPermissions(['Access contents information', 'View', 'Edit'],\
      #    ZopeTestCase.user_role)
      #self.login()
      #response=self.publish(_url)
      #response=self.publish(_url,self.basic_auth)
      #print response

      #_url='testMade/testImage/annotation_1.html?level=0&center_x=415&'+\
      #    'center_y=247&width=640&height=480&format=png&click_x=558&click_y=339'
      #response=self.publish(_url)
      #assert response.getBody().find('add_annotation_handler_step_1?next'+\
      #    '=annotation_2.html')!=-1, 'handler_step_1 link not shown'
      #assert response.getBody().find('src="get_image?level=0&amp;center_x'+\
      #    '=415')!=-1, 'handler_step_1 image not shown'
      #_url='testMade/testImage/add_annotation_handler_step_1?next='+\
      #    'annotation_2.html'+\
      #    '&level=0&center_x=415&center_y=247&width=640&height=480&format'+\
      #    '=png&click_point=150,150'

      
    def testAnnotationPosition(self):
      #TODO : fix this test to use the iframe that the annotations are in
      id=self.app.testMade.generateId()
      self.app.testMade.testImage.addAnnotation(Annotation(200,200,300,300,id))
      self.app.testMade.testImage.getAnnotation(id).editData(\
                                  text='testAnnoPos', title='testAnnoPosTitle')
      _url='testMade/testImage?level=0&center_x=250&center_y=250&width=640&'+\
                    'height=480&format=png&click_point=320,240'
      res=self.publish(_url).getBody()
      #assert re.search("made:coordinates=\"\(200, 200, 300, 300\)\"", res),\
      #    "Annotation coordinates not shown: "+res
    
    def testAnnotationClicking(self):
      id=self.app.testMade.generateId()
      self.app.testMade.testImage.addAnnotation(Annotation(0,0,100,100,id))
      self.app.testMade.testImage.getAnnotation(id).editData(\
                                  text='testTextAnnotation', title='testTitle')
      id=self.app.testMade.generateId()
      self.app.testMade.testImage.addAnnotation(Annotation(100,100,200,200,id))
      self.app.testMade.testImage.getAnnotation(id).editData(\
          url='http://nohost/foo123')

      _url='testMade/testImage?level=0&center_x=25&center_y=25&width=640&'+\
          'height=480&format=png&click_point=320,240'
      res=self.publish(_url).getBody()
      assert re.search('<p class=\"text\">testTextAnnotation</p>', res),\
          'Text annotation not shown after clicking: '+res 
      assert re.search('<h4>testTitle</h4>', res),\
          'Annotation title not shown after clicking: '+res

      _url='testMade/testImage?level=0&center_x=150&center_y=150&width=640&'+\
          'height=480&format=png&click_point=320,240'
      #res=self.publish(_url).
      #assert res.getStatus()==302, 'Clicking link annotation didnt redirect'
      #assert re.search('Location: http://nohost/foo123', res.getOutput()),\
      #    'clicking link annotation didnt redirect to right place'
      res=self.publish(_url).getBody()
      assert re.search("href=\"http://nohost/foo123\">", res),\
          'Annotation link not shown '+res

    def testRSS(self):
      id=self.app.testMade.generateId()
      self.app.testMade.testImage.addAnnotation(Annotation(0,0,100,100,id))
      self.app.testMade.testImage.getAnnotation(id).editData(\
                                  text='testTextAnnotation', title='testTitle')
      res=self.publish('testMade/testImage/annotations.xml').getBody()
      assert re.search('<description>testTextAnnotation</description>',res),\
          'Description not found in rss.'
      assert re.search('testMade/testImage/locateAnnotation\?id=a0',res),\
          'Link to annotation not found in rss feed.'

def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestUiAnnotations))
    return suite

if __name__ == '__main__':
    framework()

