/* Copyright 2005 by
           Atte Timonen
           Tarmo Toikkanen
           Teemu Leinonen
           Lily Diaz
           Janne Pietarila
           
 Code snippets used from Fle3 (fle3.uiah.fi),
 credits go to the Fle3 Team.

 This file is part of the ImaNote product.

 ImaNote is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
                                                                                 ImaNote is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of                  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with ImaNote; if not, write to the Free Software
 Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

function preventDefault(event){
  if (event.preventDefault) event.preventDefault();
  if (window.event) window.event.returnValue=false;
  event.cancelBubble=true
  if (event.stopPropagation) {
    event.stopPropagation()
  }
}

function addListener(element, event, funkkari){
  if (getBrowser()=='ie'){
    removeListener(element, event, funkkari) //TODO get rid of this, somehow
    //more listeners just keep on coming.
    element.attachEvent('on'+event, funkkari)
  }
  else{
    element.addEventListener(event, funkkari, true);
  }
}

function removeListener(element, event, funkkari){
  if (getBrowser()=='ie'){
    element.detachEvent('on'+event, funkkari)
  }
  else{
    element.removeEventListener(event, funkkari, true);
  }
}

//Opera's hasAttribute doesn't seem to work very well, so implement our own.
function hasAttr(elem, attr){
  len=elem.attributes.length
  var retVal=false
  for (p=0;p<len;p++){
    if (elem.attributes[p].name==attr) {
      retVal=true
      break
    }
  }
  return retVal
}

function getAttr(elem, attr){
  len=elem.attributes.length
  for (p=0;p<len;p++){
    if (elem.attributes[p].name==attr) return elem.attributes[p].value
  }
  return ""
}

function createHiddenInput(form, name, value){
  inp=document.createElement("input")
  inp.setAttribute("type", "hidden")
  inp.setAttribute("name", name)
  inp.setAttribute("value", value)
  form.appendChild(inp)
}

function getEventTarget(event){
  if (getBrowser()=='ie'){
    return window.event.srcElement
  }
  else {
    return event.target
  }
}

function getParent(element){
  if (getBrowser()=='ie'){
    return element.parentNode
  }
  else{
    return element.parentNode
  }
}

function getScreenSizeX(){
  if(window.innerWidth)
    return window.innerWidth
  if (document.documentElement.clientHeight)
    return document.documentElement.clientHeight
  if (document.body.clientWidth)
    return document.body.clientWidth
}
function getScreenSizeY(){
  if(window.innerHeight)
    return window.innerHeight
  if (document.documentElement.clientHeight)
    return document.documentElement.clientHeight
  if (document.body.clientHeight)
    return document.body.clientHeight
}

function getX(event){
  target=getEventTarget(event)
  if (target==imageLink||getParent(target)==imageLink) offset=getParent(getParent(getParent(target))).offsetLeft
  else offset=0
  if (getParent(target)==smallmapLink){
    offset=15
    offset+=getParent(getParent(target)).offsetLeft
  }
  if(getBrowser()=='mozilla'){
    return event.pageX-offset
  }
  if(getBrowser()=='opera'){
    return event.pageX-offset
  }
  if (getBrowser()=='ie'){
    return event.clientX-offset
  }
  if (event.offsetX==undefined){
    return event.layerX
  }
  else{
    x=event.offsetX
  }
  return x;
}
function getCoord(event, x, bigmap){
  if (bigmap){
    offsetElem=getParent(getParent(imageLink))
    offsetX=offsetElem.offsetLeft
    offsetY=offsetElem.offsetTop
  }
  else{
    offsetElem=getParent(smallmapLink)
    offsetX=22+offsetElem.offsetLeft
    offsetY=offsetElem.offsetTop
  }
  if (getBrowser()=='mozilla'||getBrowser()=='opera'){
    if (x) return event.pageX-offsetX
    else return event.pageY-offsetY
  }
  if (getBrowser()=='ie'){
    if (x) return event.clientX-offsetX
    else return event.clientY-offsetY
  }
}
function getY(event){
  target=getEventTarget(event)
  //alert(getParent(getParent(getParent(target))).offsetTop)
  if (target==imageLink||getParent(target)==imageLink) offset=getParent(getParent(getParent(target))).offsetTop
  else offset=0
  if (getParent(target)==smallmapLink){
    offset=getParent(getParent(target)).offsetTop
  }
  if(getBrowser()=='mozilla'){
    return event.pageY-offset
  }
  if(getBrowser()=='opera'){
    return event.pageY-offset
  }
  if (getBrowser()=='ie'){
    return event.clientY-offset
  }
  //offsetX doesnt work in firefox/mozilla
  if (event.offsetY==undefined){
    y=event.layerY
  }
  else{
    y=event.offsetY
  }
  return y;
}

